org.apache.commons.math.stat.descriptive.moment

## Class Kurtosis

- java.lang.Object
- - org.apache.commons.math.stat.descriptive.AbstractUnivariateStatistic
  - - org.apache.commons.math.stat.descriptive.AbstractStorelessUnivariateStatistic
    - - org.apache.commons.math.stat.descriptive.moment.Kurtosis

All Implemented Interfaces:
  Serializable, StorelessUnivariateStatistic, UnivariateStatistic

    public class Kurtosis
    extends AbstractStorelessUnivariateStatistic
    implements Serializable

Computes the Kurtosis of the available values.

We use the following (unbiased) formula to define kurtosis:

kurtosis = { [n(n+1) / (n -1)(n - 2)(n-3)] sum[(x_i - mean)^4] / std^4 } - [3(n-1)^2 / (n-2)(n-3)]

where n is the number of values, mean is the `Mean` and std is the `StandardDeviation`

Note that this statistic is undefined for n < 4. `Double.Nan` is returned when there is not sufficient data to compute the statistic.

Note that this implementation is not synchronized. If multiple threads access an instance of this class concurrently, and at least one of the threads invokes the `increment()` or `clear()` method, it must be synchronized externally.

Version:
  $Revision: 1006299 $ $Date: 2010-10-10 16:47:17 +0200 (dim. 10 oct. 2010) $
See Also:
  Serialized Form

### Field Summary

Fields
`protected boolean` `incMoment` Determines whether or not this statistic can be incremented or cleared.
`protected FourthMoment` `moment` Fourth Moment on which this statistic is based
`private static long` `serialVersionUID` Serializable version identifier

### Constructor Summary

Constructors
Constructor and Description
`Kurtosis()` Construct a Kurtosis
`Kurtosis(FourthMoment m4)` Construct a Kurtosis from an external moment
`Kurtosis(Kurtosis original)` Copy constructor, creates a new `Kurtosis` identical to the `original`

### Method Summary

Methods
`void` `clear()` Clears the internal state of the Statistic
`Kurtosis` `copy()` Returns a copy of the statistic with the same internal state.
`static void` `copy(Kurtosis source, Kurtosis dest)` Copies source to dest.
`double` `evaluate(double[] values, int begin, int length)` Returns the kurtosis of the entries in the specified portion of the input array.
`long` `getN()` Returns the number of values that have been added.
`double` `getResult()` Returns the current value of the Statistic.
`void` `increment(double d)` Updates the internal state of the statistic to reflect the addition of the new value.

### Methods inherited from class org.apache.commons.math.stat.descriptive.AbstractStorelessUnivariateStatistic

`equals, evaluate, hashCode, incrementAll, incrementAll`

### Methods inherited from class org.apache.commons.math.stat.descriptive.AbstractUnivariateStatistic

`evaluate, getData, getDataRef, setData, setData, test, test`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### serialVersionUID

    private static final long serialVersionUID

Serializable version identifier

See Also:
  Constant Field Values

#### moment

    protected FourthMoment moment

Fourth Moment on which this statistic is based

#### incMoment

    protected boolean incMoment

Determines whether or not this statistic can be incremented or cleared.

Statistics based on (constructed from) external moments cannot be incremented or cleared.

### Constructor Detail

#### Kurtosis

    public Kurtosis()

Construct a Kurtosis

#### Kurtosis

    public Kurtosis(FourthMoment m4)

Construct a Kurtosis from an external moment

Parameters:
  `m4` - external Moment

#### Kurtosis

    public Kurtosis(Kurtosis original)

Copy constructor, creates a new `Kurtosis` identical to the `original`

Parameters:
  `original` - the `Kurtosis` instance to copy

### Method Detail

#### increment

    public void increment(double d)

Updates the internal state of the statistic to reflect the addition of the new value.

Specified by:
  `increment` in interface `StorelessUnivariateStatistic`
Specified by:
  `increment` in class `AbstractStorelessUnivariateStatistic`
Parameters:
  `d` - the new value.

#### getResult

    public double getResult()

Returns the current value of the Statistic.

Specified by:
  `getResult` in interface `StorelessUnivariateStatistic`
Specified by:
  `getResult` in class `AbstractStorelessUnivariateStatistic`
Returns:
  value of the statistic, `Double.NaN` if it has been cleared or just instantiated.

#### clear

    public void clear()

Clears the internal state of the Statistic

Specified by:
  `clear` in interface `StorelessUnivariateStatistic`
Specified by:
  `clear` in class `AbstractStorelessUnivariateStatistic`

#### getN

    public long getN()

Returns the number of values that have been added.

Specified by:
  `getN` in interface `StorelessUnivariateStatistic`
Returns:
  the number of values.

#### evaluate

    public double evaluate(double[] values,
                  int begin,
                  int length)

Returns the kurtosis of the entries in the specified portion of the input array.

See `Kurtosis` for details on the computing algorithm.

Throws `IllegalArgumentException` if the array is null.

Specified by:
  `evaluate` in interface `UnivariateStatistic`
Overrides:
  `evaluate` in class `AbstractStorelessUnivariateStatistic`
Parameters:
  `values` - the input array
  `begin` - index of the first array element to include
  `length` - the number of elements to include
Returns:
  the kurtosis of the values or Double.NaN if length is less than 4
Throws:
  `IllegalArgumentException` - if the input array is null or the array index parameters are not valid
See Also:
  `UnivariateStatistic.evaluate(double[], int, int)`

#### copy

    public Kurtosis copy()

Returns a copy of the statistic with the same internal state.

Specified by:
  `copy` in interface `StorelessUnivariateStatistic`
Specified by:
  `copy` in interface `UnivariateStatistic`
Specified by:
  `copy` in class `AbstractStorelessUnivariateStatistic`
Returns:
  a copy of the statistic

#### copy

    public static void copy(Kurtosis source,
            Kurtosis dest)

Copies source to dest.

Neither source nor dest can be null.

Parameters:
  `source` - Kurtosis to copy
  `dest` - Kurtosis to copy to
Throws:
  `NullPointerException` - if either source or dest is null